routes/web.php
<?php

use App\Http\Controllers\HomeController;
use App\Http\Controllers\NotificationController;
use App\Http\Controllers\ListReserva;
use App\Http\Controllers\PersonController;
use App\Http\Controllers\ReserveController;
use App\Http\Controllers\ListDraftsController;
use App\Http\Controllers\ListInformationController;
use \App\Http\Controllers\ReserveClassroomController;
use \App\Http\Controllers\ReportController;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Auth::routes();

//home
Route::get('/', [HomeController::class, 'index'])->name('home');
Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home'); //RUTA USUARIO
Route::get('admin/home', [App\Http\Controllers\HomeController::class, 'adminHome'])->name('admin.home')->middleware('is_admin');// RUTA ADMI
Route::get('/home', function () {
    return view('home');
})->name('myHome');//VISTA HOME INICIAL(sin iniciar sesion)

//list subjects
Route::resource('list-subjects', PersonController::class);
Route::get('/list-subjects', [PersonController::class,'index'])->name('subjects');

// reserve form
Route::resource('reserves', ReserveController::class);

// reserve form draf
Route::get('draft', [ReserveController::class,'draftStore'])->name('draft');
Route::get('reserves/create/{courseId}', [ReserveController::class, 'create', ])->name('create.reserve');

// lista de borradores
Route::resource('myListDrafts', ListDraftsController::class);

// Lista de reportes
Route::resource('reports', ReportController::class);

/*Administrador*/
//lista de reservas
Route::resource('ListReserve', ListReserva::class);
Route::resource('ListReserve', ListReserva::class)->middleware('is_admin');
Route::resource('respuestas', ReserveClassroomController::class)->middleware('is_admin');
Route::get('ListReserve/show/{formId}', [ListReserva::class, 'show', ])->name('show.ListReserve')->middleware('is_admin');

Route::resource('ListInformation', ListInformationController::class)->middleware('is_admin');

Route::post('ListReserve/filter', [ListReserva::class,'filter'])->name('filter')->middleware('is_admin');

Route::get('create-notification', [NotificationController::class,'create'])->middleware('is_admin');

resources/views/docenteAuxiliar/editForm.blade.php
@extends('layouts.app')

@section('content')


    <link rel="preconnect" href="https://fonts.googleapis.com">
    <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
    <link href="https://fonts.googleapis.com/css2?family=Poppins:wght@300&display=swap" rel="stylesheet">
    <style>
        .locked-tag .select2-selection__choice__remove{
            display: none!important;
        }
    </style>
    <div class="container p-0" >
        <br/>
        @if (session('alert-type') == 'success')
            @push('scripts')
                <script type="text/javascript">
                    jQuery(function($) {
                        $('#sendModal').modal('show');
                    });
                </script>
            @endpush
        @endif

        @php
            $idUser= Auth::user()->id;
        @endphp

        <div class="d-flex justify-content-center">
            <div class="col-8">
                <h3 class="text-center mt-1" style="color: #215F88;">Editar Reserva - {{$reserva->id_form}}</h3>
                <p class="text-secondary mt-2 p-2"> Todos los campos son requeridos para enviar una solicitud de reserva</p>
                <form id="testF" class="needs-validation border rounded p-3" novalidate method="post" action="{{ route('reserves.store') }}">
                    {{ csrf_field() }}
                    <input type="text" name="id_reserva" value={{$reserva->id_form}} hidden>
                    <div class="mb-3">
                        <label for="inputSolicitante" class="form-label fw-bold">Nombre Solicitante(s)</label>
                        <select class="multi-select form-control" multiple name="solicitantes[]" id="inputSolicitante" style="width: 100%">
                            <option selected locked="locked" value={{$def->id_assign_subject}}>{{$def->person->first_name}} {{$def->person->last_name}}</option>
                            @foreach($cursos as $curso)
                                @if(in_array($curso->id_assign_subject, $reserva->cursos->pluck('id_assign_subject')->toArray()))
                                    <option selected value={{$curso->id_assign_subject}}>{{$curso->person->first_name}} {{$def->person->last_name}}</option>
                                    @else
                                    <option value={{$curso->id_assign_subject}}>{{$curso->person->first_name}} {{$def->person->last_name}}</option>
                                @endif
                            @endforeach
                        </select>
                        @if ($errors->has('solicitantes'))
                            <span class="text-danger">{{ $errors->first('solicitantes') }}</span>
                        @endif
                    </div>
                    <!--<div class="mb-3">
                        <label for="inputMateria" class="form-label">Materia</label>
                        <input type="text" class="form-control" id="inputMateria" disabled readonly value={{$def->subject->name_subject}} name="materia">
                    </div>-->
                    <div class="mb-3">
                        <label for="inputMateria" class="form-label">Materia</label>
                        <div class="card">
                            <div class="card-body" style="padding: 5px;">{{$def->subject->name_subject}}</div>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-lg mb-3">
                            <label for="inputGrupos" class="form-label">Grupo(s)</label>
                            <select class="multi-select form-control" multiple name="grupos[]" id="inputGrupos" >
                                <option selected locked="locked" value={{$def->group_number}}>{{$def->group_number}}</option>
                                @foreach($cursos as $curso)
                                    @if(in_array($curso->id_assign_subject, $reserva->cursos->pluck('id_assign_subject')->toArray()))
                                    <option selected value={{$curso->group_number}}>{{$curso->group_number}}</option>
                                    @else
                                        <option value={{$curso->group_number}}>{{$curso->group_number}}</option>
                                    @endif
                                @endforeach
                            </select>
                            @if ($errors->has('grupos'))
                                <span class="text-danger">{{ $errors->first('grupos') }}</span>
                            @endif
                        </div>
                        <div class="col-lg mb-3">
                                <label for="inputEstudiantes" class="form-label">Estudiantes</label>
                                <input
                                    type="number"
                                    class="form-control"
                                    id="inputEstudiantes"
                                    name='estudiantes'
                                    value={{$reserva->number_students ?? ''}}>
                                @if ($errors->has('estudiantes'))
                                    <span class="text-danger">{{ $errors->first('estudiantes') }}</span>
                                @endif
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-lg mb-3">
                                <label for="inputMotivo" class="form-label">Motivo</label>
                                <select class="form-select" id="inputMotivo" name="motivo">
                                    @foreach($motivos as $motivo)
                                        @if($motivo->id_motive == $reserva->id_motive)
                                            <option selected value={{$motivo->id_motive}}>{{$motivo->type_motive}}</option>
                                        @else
                                            <option value={{$motivo->id_motive}}>{{$motivo->type_motive}}</option>
                                        @endif
                                    @endforeach
                                </select>
                                @if ($errors->has('motivo'))
                                    <span class="text-danger">{{ $errors->first('motivo') }}</span>
                                @endif

                            </div>
                            <div class="col-lg mb-3">
                                <label for="inputFecha" class="form-label">Fecha</label>
                                <input type="date" class="form-control" id="inputFecha" name="fecha" value={{$reserva->date_reserve}}>
                                @if ($errors->has('fecha'))
                                    <span class="text-danger">{{ $errors->first('fecha') }}</span>
                                @endif

                            </div>
                        </div>
                        <div class="mb-3 col-md-12">
                            <label for="inputPeriodos" class="form-label">Periodo(s)</label>
                            <select class="mul-select form-control" multiple name="periodos[]" id="inputPeriodos" style="width: 100%">
                                @foreach($periodos as $periodo)
                                    @if(in_array($periodo->id_class_timetable, $reserva->periodos->pluck('id_class_timetable')->toArray()))
                                        <option selected value={{$periodo->id_class_timetable}}>{{$periodo->timetable_range}}</option>
                                    @else
                                        <option value={{$periodo->id_class_timetable}}>{{$periodo->timetable_range}}</option>
                                    @endif
                                @endforeach
                            </select>
                            @if ($errors->has('periodos'))
                                <span class="text-danger">{{ $errors->first('periodos') }}</span>
                            @endif

                        </div>
                        <div class="row mb-3">
                            <div class="col" style="text-align: end; padding: 0 22px 0 0">
                                <label class="col form-label">Si no se encuentra un aula, <br> ¿Podemos sugerirle aulas continuas ?</label>
                            </div>

                            <div class="col" style="text-align:start ; padding: 23px 0 0 0" >
                                <div class="form-check form-check-inline">
                                    <input class="form-check-input" type="radio" name="continuous_classroom" id="checkYes" value="1">
                                    <label class="form-check-label" for="inlineRadio1">Si</label>
                                </div>
                                <div class="form-check form-check-inline">
                                    <input class="form-check-input" type="radio" name="continuous_classroom" id="checkNo" value="0">
                                    <label class="form-check-label" for="inlineRadio2">No</label>
                                </div>
                                    @if ($errors->has('continuous_classroom'))
                                        <span class="text-danger">{{ $errors->first('continuous_classroom') }}</span>
                                    @endif
                            </div>
                        </div>
                    <!--Botones-->
                    <div class="d-flex justify-content-end gap-2">
                        <button type="submit" class="btn btn-warning" name="action" value="editar">Guardar en Borrador</button>
                        <button type="button" class="btn btn-secondary" onclick="cancelarReserva()">Cancelar</button>
                        <button type="submit" style="background-color: #215F88; color: white" class="btn" name="action" value="enviar">Enviar</button>
                    </div>
                </form>
            </div>
        </div>
    </div>
    <x-alerta :user="$idUser"/>
    <script>
        const courses = {{ Js::from($cursos->push($def))}};
        const reservaAulaContinua = {{Js::from($reserva->continuous_classroom)}};
    </script>
    <script src="{{ asset('js/components/form.js')}}" ></script>
    <script src="{{ asset('js/components/validation.js')}}" ></script>
    <script>
        const aulaContinua = reservaAulaContinua;
        if (aulaContinua) {
            $('#checkYes').prop('checked', true);
        } else {
            $('#checkNo').prop('checked', true);
        }

    </script>
@endsection

resources/views/docenteAuxiliar/form.blade.php
@extends('layouts.app')

@section('content')


    <link rel="preconnect" href="https://fonts.googleapis.com">
    <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
    <link href="https://fonts.googleapis.com/css2?family=Poppins:wght@300&display=swap" rel="stylesheet">
    <style>
        .locked-tag .select2-selection__choice__remove{
            display: none!important;
        }
        .error {
            color:red;
        }
        @media only screen and (min-width: 576px) { 
            .booking {
                margin: 0 4rem;
            }
        }
        @media only screen and (max-width: 575px) { 
            .booking {
                margin: 0 1rem;
            }
        }
    </style>
    <div class="container p-0" >
        <br/>
        @if (session('message'))
            @push('scripts')
                <script type="text/javascript">
                    jQuery(function($) {
                        $('#sendModal').modal('show');
                    });
                </script>
            @endpush
        @endif

        @php
            $idUser= Auth::user()->id;
        @endphp

        <div class="d-flex justify-content-center">
            <div class="booking">
                <h3 class="text-center mt-1" style="color: #215F88;">Crear nueva reserva</h3>
                <p class="text-secondary mt-2 p-2"> Todos los campos son requeridos para enviar una solicitud de reserva</p>
                <form id="testF" class="needs-validation border rounded p-3" novalidate method="post" action="{{ route('reserves.store') }}">
                    {{ csrf_field() }}
                    <div class="mb-3">
                        <label for="inputSolicitante" class="form-label fw-bold">Nombre Solicitante(s)</label>
                        <select class="multi-select form-control" multiple name="solicitantes[]" id="inputSolicitante" style="width: 100%">
                            <option selected locked="locked" value={{$def->id_assign_subject}}>{{$def->person->first_name}} {{$def->person->last_name}}</option>
                            @foreach($courses as $co)
                                <option value={{$co->id_assign_subject}}>{{$co->person->first_name}} {{$co->person->last_name}}</option>
                            @endforeach
                        </select>
                        @if ($errors->has('solicitantes'))
                            <span class="text-danger">{{ $errors->first('solicitantes') }}</span>
                        @endif
                    </div>
                    <!--<div class="mb-3">
                        <label for="inputMateria" class="form-label">Materia</label>
                        <input type="text" class="form-control" id="inputMateria" disabled readonly name="materia">
                    </div>-->
                    <div class="mb-3">
                        <label for="inputMateria" class="form-label">Materia</label>
                        <div class="card">
                            <div class="card-body" style="padding: 5px;">{{$def->subject->name_subject}}</div>
                        </div>
                    </div>

                    <div class="row">
                        <div class="col-lg mb-3">
                            <label for="inputGrupos" class="form-label">Grupo(s)</label>
                            <select class="multi-select form-control" multiple name="grupos[]" id="inputGrupos" >
                                <option selected locked="locked" value={{$def->group_number}}>{{$def->group_number}}</option>
                            </select>
                            @if ($errors->has('grupos'))
                                <span class="text-danger">{{ $errors->first('grupos') }}</span>
                            @endif
                        </div>
                        <div class="col-lg mb-3">
                            <label for="inputEstudiantes" class="form-label">Estudiantes</label>
                            <input
                                type="number"
                                class="form-control"
                                id="inputEstudiantes"
                                name='estudiantes'
                                value={{$def->registered_number}}>

                        </div>
                    </div>
                    <div class="row">
                        <div class="col-lg mb-3">

                            <label for="inputMotivo" class="form-label">Motivo</label>
                            <select class="form-select" id="inputMotivo" name="motivo">
                                @foreach($motivos as $motivo)
                                    <option value={{$motivo->id_motive}}>{{$motivo->type_motive}}</option>
                                @endforeach
                            </select>
                            @if ($errors->has('motivo'))
                                <span class="text-danger">{{ $errors->first('motivo') }}</span>
                            @endif
                        </div>
                        <div class="col-lg mb-3">
                            <label for="inputFecha" class="form-label">Fecha</label>
                            <input type="date" class="form-control" id="inputFecha" name="fecha" value={{\Carbon\Carbon::now()->addDays(3)}}>
                            @if ($errors->has('fecha'))
                                <span class="text-danger">{{ $errors->first('fecha') }}</span>
                            @endif
                        </div>
                    </div>
                    <div class="mb-3 col-md-12">
                        <label for="inputPeriodos" class="form-label">Periodo(s)</label>
                        <select class="mul-select form-control" multiple name="periodos[]" id="inputPeriodos" style="width: 100%">
                            <option selected value={{$periodos[0]->id_class_timetable}}>{{$periodos[0]->timetable_range}}</option>
                            @foreach(array_slice($periodos->toArray(), 1) as $periodo)
                                <option value={{$periodo['id_class_timetable']}}>{{$periodo['timetable_range']}}</option>
                            @endforeach
                        </select>
                        @if ($errors->has('periodos'))
                            <span class="text-danger">{{ $errors->first('periodos') }}</span>
                        @endif

                    </div>

                    <div class="row mb-3">
                        <div class="col" style="text-align: end; padding: 0 22px 0 0">
                            <label class="col form-label">Si no se encuentra un aula, <br> ¿Podemos sugerirle aulas continuas ?</label>
                        </div>
                        <div class="col" style="text-align:start ; padding: 23px 0 0 0" >
                            <div class="form-check form-check-inline">
                                <input class="form-check-input" type="radio" name="continuous_classroom" id="inlineRadio1" checked value="1">
                                <label class="form-check-label" for="inlineRadio1">Si</label>
                            </div>
                            <div class="form-check form-check-inline">
                                <input class="form-check-input" type="radio" name="continuous_classroom" id="inlineRadio2" value="0">
                                <label class="form-check-label" for="inlineRadio2">No</label>
                            </div>
                                @if ($errors->has('continuous_classroom'))
                                    <span class="text-danger">{{ $errors->first('continuous_classroom') }}</span>
                                @endif
                        </div>
                    </div>
                    <!--Botones-->
                    <div class="d-flex justify-content-end gap-2">
                        <button type="submit" class="btn btn-warning" name="action" value="editar">Guardar en Borrador</button>
                        <button type="button" class="btn btn-secondary" onclick="cancelarReserva()">Cancelar</button>
                        <button type="submit" style="background-color: #215F88; color: white" class="btn" name="action" value="enviar">Enviar</button>
                    </div>
                </form>
            </div>
        </div>
    </div>
    <x-alerta :user="$idUser"/>
    <script>
        const courses = {{ Js::from($courses->push($def))}};
    </script>
    <script src="{{ asset('js/components/form.js')}}" ></script>
    <script src="{{ asset('js/components/validation.js')}}" ></script>
@endsection

resources/views/docenteAuxiliar/listDrafts.blade.php
@extends('layouts.app')

@section('content')
<style>
    body{
      display: grid;
      font-family: 'Poppins', sans-serif;
    }
    table{
      font-family: 'Poppins', sans-serif;
      color:black;
      font-weight: normal !important;
    }
    .h2{
      font: bold;
    }
</style>
<body>
  <div class="container">
    <br>
    <h5 class="row fw-normal" style="color: #215F88"> Mi lista de borradores </h5>
    @if (!$reservas->isEmpty())
    <br>
      <div>
          <table class="table datatable table-hover table-responsive table-bordered border-white">
              <thead>
              <tr class=" fw-lighter" style="color: #215F88">

                  <th scope="col" class=" text-center">Nro</th>
                  <th scope="col">Materia</th>
                  <th scope="col">Grupo(s)</th>
                  <th scope="col">Cant. de inscritos</th>
                  <th scope="col">Ultima Modificacion</th>
                  <th scope="col">Editar</th>
                  <!-- <th scope="col">Eliminar</th> -->
              </tr>
              </thead>
              <tbody>
              @php
                $num=1;
              @endphp
              @foreach ($reservas as $reserva)
                  <tr>
                      <!--<td scope="row" class=" text-center">{{$reserva->id_form}}</td>-->
                      <td scope="row" class=" text-center">{{$num++}}</td>

                      <td scope="row">{{$reserva->cursos->first()->subject->name_subject ?? ''}}</td>
                      @php
                          $grupos = "";
                          foreach($reserva->cursos as $curso) {
                              $grupos = $grupos.",".$curso->group_number;
                          }
                      $dataGrupos = trim($grupos,',');
                      @endphp

                      <td >{{$dataGrupos}}</td>
                      <td>{{$reserva->number_students}}</td>
                      <td>{{$reserva->updated_at}}</td>
                      <td style="align-items: center">
                          <a href="{{route('reserves.edit', $reserva->id_form)}}">
                              <h4><i class="bi bi-pencil-square" style="color: black"></i></h4>
                          </a>
                      </td>
                  <!-- <td style="align-items: center"><a href="{{route('home')}}"><img src="/images/eliminar.png" width="28px" height="28px"></a></td> -->
                  </tr>
              @endforeach
              </tbody>
          </table>
      </div>
    @else
      <br>
      <div class="text-center">
        <img src="https://firebasestorage.googleapis.com/v0/b/adaroom-3619c.appspot.com/o/save_3621.png?alt=media&token=fb4588ce-5547-4866-82de-207e1c29f831" class="rounded" width="100px" height="100px" >
      </div>
      <p class="text-center text-muted" style="color: #000000; font-size: 14px" >No se encontró ninguna borrador</p>
    @endif
  </div>
</body>
@endsection

resources/views/docenteAuxiliar/myListSubjects.blade.php
@extends('layouts.app')

@section('content')

    <style>
        body{
            min-height: 100vh;
            display: grid;
            grid-template-rows: auto auto 1fr auto ;
            font-family: 'Poppins', sans-serif;
        }
        table{
            font-family: 'Poppins', sans-serif;
            color:black;
            font-weight: normal !important;
            overflow-x: auto;
            white-space: nowrap;
        }

    </style>
<body>
    <div id="pricing" class="container">
        <br>
        <h5 class="fw-normal" style="color: #215F88"> Mi lista de materias </h5>
        <br>
        <table class="table datatable table-hover table-responsive table-bordered border-white">
            <thead>
                <tr class=" fw-lighter" style="color: #215F88">
                <th class=" text-center" scope="col">Materia</th>
                <th class=" text-center" scope="col">Grupo</th>
                <th class=" text-center" scope="col">Cant. de Inscritos</th>
                <th class=" text-center" scope="col">Acción</th>
                </tr>
            </thead>
            <tbody>

                @foreach ($assign as $ass )
                <tr>
                @foreach ($subjects as $subject)
                    @if(($subject->id_subject) == ($ass->id_subject))
                    <td><img src="/images/icono.png" width="24px" height="24px">&nbsp; &nbsp;{{{$subject->name_subject}}}</td>
                    @endif
                @endforeach

                @foreach($subjects as $subject)
                    @if(($subject->id_subject) == ($ass->id_subject))
                    <td class=" text-center">{{$ass->group_number}}</td>
                    @endif
                @endforeach

                @foreach($subjects as $subject)
                    @if(($subject->id_subject) == ($ass->id_subject))
                    <td class=" text-center">{{$ass->registered_number}}</td>
                    @endif
                @endforeach

                @foreach($subjects as $subject)
                    @if(($subject->id_subject) == ($ass->id_subject))
                    <td class=" text-center">
                        <form action="{{route('create.reserve', $ass->id_assign_subject)}}" method="get">
                        <button type="submit" class="btn" style="background: #215F88; color:white; padding: 0 8px 0 8px ">Reservar Aula
                    </button></form>

                    </td>
                    @endif
                @endforeach

                </tr>
                @endforeach

            </tbody>
        </table>
    </div>
</body>
@endsection